#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "ui_MainWindow.h"
#include "ui_dialog.h"
#include "dialog.h"
#include "mythread.h"
#include "QtDebug"
#include <QtGui>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    CurrentScore = -1;
    timer = new QTimer(this);
    timer->setInterval(50);
    timer->start();
    connect(timer,SIGNAL(timeout()),this,SLOT(TimeOut()));
    maskOn = true;
    turn = true;
    worker.terminate();
}

MainWindow::~MainWindow()
{
    delete ui;
}
void MainWindow::SetNames(QString AName, QString BName){
    ui->lblAname->setText(AName);
    ui->lblBname->setText(BName);
    ui->lblPTurn->setText(ui->lblAname->text()+ "'s" + " Turn");
}

void MainWindow::getScoreHandler()
{
    worker.toRun = this->toRun;
    worker.start();
}
bool MainWindow::getblnMask(){
    return maskOn;
}

void MainWindow::ToggleMaskHandler(){
    maskOn = !maskOn;
    switch (maskOn) {
    case true:
        ui->btnMask->setText("Hide Mask");
        break;
    case false:
        ui->btnMask->setText("Show Mask");
        break;
}
}
void MainWindow::on_btnMask_clicked(){
    MainWindow::ToggleMaskHandler();
}

void MainWindow::on_btnScore_clicked()
{
    MainWindow::getScoreHandler();
}

void MainWindow::setScore(int score)
{
    FScore = score;
    ui->lblAScore->setText(QString::number(score));
    ui->lblBScore->setText(QString::number(score));
}

void MainWindow::TimeOut()
{

    if(CurrentScore != -1)
    {
        QListWidget* list;
        QLabel *score;
        QLabel *namelabel;
        QString postfix;
        QLabel* TurnLabel;
        if(turn)
        {
            list = ui->listWidgetA;
            score = ui->lblAScore;
            namelabel = ui->lblBname;

        }
        else
        {
            list = ui->listWidgetB;
            score = ui->lblBScore;
            namelabel = ui->lblAname;
        }
        if(score->text().toInt() - CurrentScore < 0)
        {
            postfix = " (over)";
        }
        else
        {
            postfix = "";
            score->setText(QString::number(score->text().toInt() - CurrentScore));
        }
        ui->lblPTurn->setText(namelabel->text() + "'s" +  " Turn");
        list->addItem(new QListWidgetItem(QString::number(CurrentScore) + postfix));
        turn = !turn;
        CurrentScore = -1;

        if(score->text().toInt() == 0)
        {
             QMessageBox msgBox;
             msgBox.addButton(QMessageBox::Yes);
             msgBox.addButton(QMessageBox::No);
             if(turn){
             namelabel = ui->lblBname;
             }else{
             namelabel = ui->lblAname;
             }
             msgBox.setText("Congratulations! " + namelabel->text() +" Won the game!. \nWould you like to play again?");

             int selection = msgBox.exec();
             if(selection == QMessageBox::Yes)
             {
               CurrentScore = -1;
               turn = true;
               ui->listWidgetA->clear();
               ui->listWidgetB->clear();
               ui->lblAScore->setText(QString::number(FScore));
               ui->lblBScore->setText(QString::number(FScore));
             }
             else if(selection == QMessageBox::No)
             {
               this->close();
             }
        }
    }

    if(image.data)
    {
        QImage img = QImage((const unsigned char*)image.data,image.cols,
                       image.rows,image.step,QImage::Format_RGB888);

        ui->label_2->setPixmap(QPixmap::fromImage(img.rgbSwapped()));
    }



}

void MainWindow::on_btnExit_clicked()
{
    timer->stop();
    this->destroy();

}
